﻿using System;
using System.Net.Sockets;
using System.Text;

namespace RemoteProxy
{

    class Stub
    {
        Socket dosock;
        ITake itake;
        public Stub(Socket dosock, ITake itake)
        {
            this.dosock = dosock;
            this.itake = itake;
        }
        public void Do()
        {
            byte[] buffer = new byte[1];
            int n = dosock.Receive(buffer);

            MsgId msgid = (MsgId)buffer[0];
            Console.WriteLine(msgid);
            switch (msgid)
            {
                case MsgId.TAKE: TakeProc(); break;
                case MsgId.CHANGE: ChangeProc(); break;
                case MsgId.GET: GetProc(); break;
            }
            dosock.Close();
        }

        private void GetProc()
        {
            bool mode= itake.GetMode();
            byte[] msg = new byte[1];
            msg[0] = Convert.ToByte(mode);
            dosock.Send(msg);
            
        }

        private void ChangeProc()
        {
            byte[] buffer = new byte[1];
            bool mode;
            dosock.Receive(buffer);
            mode = Convert.ToBoolean(buffer[0]);
            itake.ChangeMode(mode);                        
        }

        private void TakeProc()
        {
            string picture = itake.TakeAPicture();
            byte[] msg = Encoding.UTF8.GetBytes(picture);
            dosock.Send(msg);
        }
        
    }
}
